import pandas as pd
import numpy as np
from sklearn.neighbors import KNeighborsClassifier
import serial
import time
import csv
#preparation stuff
name = 'Martin G'
datasetFile = '{0}_dataset.csv'
datalogFile = '{0}_datalog.csv'
datalog = open(datalogFile,'ab')
csvLogger = csv.writer(datalog,quoting = csv.QUOTE_ALL)
#minimal preprocessing
df = pd.read_csv(datasetFile.drop(['year','month','Date','time'],axis=1)
features = df.drop('Label')
labels = df.Label
#training classifier
classifier = KNeighborsClassifier(5,algorithm='kd_tree')
classifier.fit(features,labels)
#arduino setup
arduino = serial.Serial('/dev/tty/ACM0',115200)
time.sleep(.1)
#arduino reading
def arduinoRead(whatToDo);
    arduino.write(whatToDo)
    While True:
        if arduino.inwaiting > 0:
            data = arduino.readline
            data = data.rstrip('\r\n')
            data = data.split(',')
            if len(data)==16:
                for i in data:
                    data = int(data)
                break
    return data
#predict
def predictSeating():
    dataPoint = arduinoRead()
    prediction = classifier.predict(dataPoint)[]
    return prediction

def csvRestartRead():
    datalog.close()
    log = pd.read_csv().Label.tail[900]
    datalog = open(datalogFile,'ab')
    csvLogger = csv.writer(datalog,quoting = csv.QUOTE_ALL)
    return log
