
#include <SparkFunLSM6DS3.h>
#include <Wire.h>
#include <SPI.h>
LSM6DS3 myIMU( I2C_MODE, 0x6A );  //accel-gyro

int in1 = 24;
int in2 = 26;
int Position;
int hijack1 = 8;
int hijack2 = 7;
int pushbutton = 10;
int LPot = 0;
long previousMillis = 0;
String state ;
String msg;
int buttonState;
//buttons

void setup() {
  // Open serial communications and wait for port to open:
  Wire.begin();
  Serial.begin(115200);
  pinMode (pushbutton, INPUT);
  pinMode(hijack1, INPUT);
  pinMode(hijack2, INPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  digitalWrite(in1, LOW);
  digitalWrite(in2, LOW);

  if ( myIMU.begin() != 0 )
  {
    Serial.println("Device error");
  }
  int Postition = analogRead(LPot);
}

void loop() {
  while ( Serial.available() == 0) {}
  String msg = "";
  while (Serial.available() > 0)
  {
    msg += char(Serial.read());
    delayMicroseconds(60);
  }
  if (msg == "Pressure") {
    String dataString = "";
    // read three sensors and append to the string:
    for (int analogPin = 5; analogPin < 15; analogPin++) {
      int sensor = analogRead(analogPin);
      dataString += String(sensor);
      if (analogPin < 14)
      {
        dataString += ",";
      }
    }
    dataString += myIMU.readFloatAccelX(), 10;
    dataString += ",";
    dataString += myIMU.readFloatAccelY(), 10;
    dataString += ",";
    dataString += myIMU.readFloatAccelZ(), 10;
    dataString += ",";
    dataString += myIMU.readFloatGyroX(), 4;
    dataString += ",";
    dataString += myIMU.readFloatGyroY(), 4;
    dataString += ",";
    dataString += myIMU.readFloatGyroZ(), 4;
    buttonState = digitalRead(pushbutton);
    if (buttonState == 1) {
      dataString = "ShutDown";
    }
    if (digitalRead(hijack1) == HIGH) {
      dataString = "Tighter";
    }
    if (digitalRead(hijack2) == HIGH) {
      dataString = "Looser";
    }
    Serial.println(dataString);
    previousMillis = millis();
  }
  else if (msg == "Startup")
  {
    software_Reset();
  }
  else if (msg == "Position") {
    Serial.println(analogRead(LPot));
  }
  else {
    //"adress of slave" + "," + "message for slave(0 if request)"
    String dir = getValue(msg, ',', 0);
    int variable = getValue(msg, ',', 1).toInt();
    motorControl(dir, variable);
  }
}
String getValue(String data, char separator, int index)
{
  int found = 0;
  int strIndex[] = { 0, -1 };
  int maxIndex = data.length() - 1;

  for (int i = 0; i <= maxIndex && found <= index; i++) {
    if (data.charAt(i) == separator || i == maxIndex) {
      found++;
      strIndex[0] = strIndex[1] + 1;
      strIndex[1] = (i == maxIndex) ? i + 1 : i;
    }
  }
  return found > index ? data.substring(strIndex[0], strIndex[1]) : "";
}
void software_Reset() // Restarts program from beginning but does not reset the peripherals and registers
{
  asm volatile ("  jmp 0");
}



