import pandas as pd
from matplotlib import pyplot as plt
import numpy
import seaborn as sns
from sklearn import preprocessing
df = pd.read_csv('D:\Cloud\SkyTenestar\Raspberry5.6.2017.csv')
df = df[df['Tilt Resistance']!=0]
df = df[df['Label']!='Seat Available']
smaller = df[['Tilt Resistance','Label']]
df = df.drop(["Label","Time","Day","Month","Year"],axis = 1)

overview =smaller.groupby (by = ['Tilt Resistance','Label']).size() #shows mean sensor values for given tilt resistance
#print overview
myDF = []
for resistance in numpy.sort(smaller['Tilt Resistance'].unique()):

    d= overview[resistance]
    #print overview[resistance]

    myDF.append(d)
myDF = pd.DataFrame(myDF,index=pd.Index([1,2,3,4,5],name = 'Tilt Resistance'))
myDF = myDF.fillna(0)
fig = plt.figure('Posture tendencies w/ different tilt resistances')
fig.add_subplot(1, 2, 1)
sns.heatmap(myDF,annot=True)
plt.xticks(rotation=45)

#print myDF
#np_scaled = []
min_max_scaler = preprocessing.MinMaxScaler()

for row in myDF.iterrows():
   # print type(row[index])
    #print row[1].values
    norm = min_max_scaler.fit_transform(row[1].values.reshape(-1,1))
    for i in range(len(norm)):
        row[1][i]=norm[i]
    #myDF.set_value(row[1],norm)
    #row[1].replace(value=norm)
    #np_scaled.append(norm)
    #print np_scaled
#for row in myDF.iterrows():
#    row = (row-row.mean())/row.std

#pd.DataFramw.from_items()
fig.add_subplot(1, 2, 2)
sns.heatmap(myDF,annot=True)
plt.xticks(rotation=45)
sns.plt.show()
