import pandas as pd
from pandas_ml import ConfusionMatrix
import numpy
from sklearn import cross_validation
from sklearn.tree import DecisionTreeClassifier
from sklearn.ensemble import RandomForestClassifier
from sklearn import neighbors, datasets
from sklearn import svm
from sklearn.metrics import accuracy_score
from time import time
from time import sleep
from collections import Counter
from sklearn.model_selection import train_test_split
import matplotlib.pyplot as plt
from sklearn import svm

def preProcessing(dataset):
    trainValidation_dataset = dataset.drop(['Year','Month','Date','Time','Accell X','Accell Y','Accell Z','Gyro X','Gyro Y','Gyro Z'],1)

    train, validation = train_test_split(trainValidation_dataset, test_size=0.2)

    # labels
    labels_train = train['Label']
    labels_validation = validation['Label']

    # features
    features_train = train.drop('Label', 1)
    features_validation = validation.drop('Label', 1)



    return features_train, features_validation, labels_train, labels_validation


#train model
def model_train(features_train, features_validation, labels_train, labels_validation):




    # KD-Tree
    t0 = time()
    clfKD = neighbors.KNeighborsClassifier(8, weights='distance', algorithm='kd_tree')
    clfKD.fit(features_train, labels_train)
    validation = clfKD.predict(features_validation)
    print 'KD Initialize speed:', round((time() - t0) * 1000, 2), 'ms'
    t0 = time()
    print 'KD Marginal 1000:', round((time() - t0) * 1000, 2), 'ms'
    print 'Validation accuracy\t', accuracy_score(labels_validation, validation)

    sReal=pd.Series(labels_validation).reset_index(drop = True)
    sGuessed = pd.Series(validation)
    mistakes = sReal.to_frame().join(sGuessed.to_frame())
    mistakes.columns=['Real','Guessed']
    #mistakes=pd.concat(dict(sReal=sReal,sGuessed=sGuessed),axis=1).reset_index(drop=True)
    mistakes = mistakes[mistakes['Real'] != mistakes['Guessed']]
    #mistakes.plot(kind='bar')
    print 'mistakes:\n', mistakes
    mistakes = mistakes.groupby(['Real','Guessed']).size()
    print 'printing\n',mistakes,'\n',type(mistakes)
   # print '\n',list(mistakes.columns.values)

    return clfKD, sReal, sGuessed,


def arduino_read(arduinoLine,classifier,df):



    df.drop(['year', 'month', 'Date', 'time','Label'],axis=1,inplace=True)



    #dataline = pd.Series(arduinoLine, index=list(df))
    #print dataline
    #dataline = dataline.reshape(1, -1)
    #print dataline
    #arduinoLine = arduinoLine.reshape(1, -1)
    prediction = classifier.predict(arduinoLine)
    print arduinoLine

    print prediction
    return prediction


def single_pred(data, classifier):
    s = pd.Series(data,index=['P1','P2','P3','P4','P5','P6','P7','P8','P9','P10','P11','P12','P13','P14','P15','P16',])
    s = s.reshape(1, -1)
    prediction = classifier.predict(s)[0]
    print prediction
    return prediction


def dataset_evaluate(csv):
    dataset = pd.read_csv(csv)
    # print dataset

    # machine_learning.model_train(machine_learning.preProcessing(dataset))
    features_train, features_validation, labels_train, labels_validation = preProcessing(dataset)

    classifier, y_true, y_pred = model_train(features_train, features_validation, labels_train,
                                                              labels_validation)

    # Plot non-normalized confusion matrix
    cm = ConfusionMatrix(y_true, y_pred)
    print cm, type(cm)
    print cm.stats()
    cm.plot(backend='seaborn', normalized=True)
    plt.xticks(rotation=60)
    plt.yticks(rotation='horizontal')
    plt.title('Quality of dataset')
    cm.plot(normalized=True)
    plt.show(block=False)
    print 'Returning to main program!'
    return