import sys, pygame, random, pandas, machine_learning
from menu import *
from image import *
import datetime
import time
import arduino_stuff
import csv
myfont = pygame.font.SysFont("calibri", 25,bold=True)
import MachineLearning_Test_function


date_list= [datetime.datetime.now().year,datetime.datetime.now().month,datetime.datetime.now().day]



def readKey(whichKey,filename,arduino,positions):

    pressedDict = {whichKey:1}

    keyDict = {10: pygame.K_0, 1: pygame.K_1, 2: pygame.K_2, 3: pygame.K_3, 4: pygame.K_4, 5: pygame.K_5,
               6: pygame.K_6, 7: pygame.K_7, 8: pygame.K_8, 9: pygame.K_9, 11: pygame.K_q, 12: pygame.K_w,
               13: pygame.K_e, 14: pygame.K_r, 15: pygame.K_t, 16: pygame.K_y, 17: pygame.K_u, 18: pygame.K_i,
               19: pygame.K_o, 20: pygame.K_p}

    lastTime=time.time()
    while pressedDict[whichKey] == 1:
        for event in pygame.event.get():
            if event.type == pygame.KEYUP:
                if event.key == keyDict[whichKey]:
                    pressedDict[whichKey] = 0
        if time.time() - lastTime > .5:
            data = arduino_stuff.sensorRead('Pressure',arduino)

            organizingStuff = [positions[whichKey-1], str(date_list[0]), str(date_list[1]),
                 str(date_list[2]), str(datetime.datetime.now().time().replace(microsecond=0))]
            newLine=data+organizingStuff
            filename.writerow(newLine)
            lastTime = time.time()
            print '%s was recorded'%positions[whichKey-1]
            print data



def menu_chair(filename,arduino,positions,name,csvLogFile):

    #csvFile
    csvFile = open(filename, 'ab')
    writer = csv.writer(csvFile, quoting=csv.QUOTE_ALL)

    csvLog = open(csvLogFile,'ab')
    csvLogger = csv.writer(csvLog, quoting=csv.QUOTE_ALL)

    Test_dataset = 'C:\Users\osmun\Desktop\Capisco\Datasets/Test_%s.csv'%name
    Test = open(Test_dataset, 'ab')
    try:
        pandas.read_csv('C:/Users/osmun/Desktop/Ongoing/CHAIR/Master/Datasets/Test_%s.csv'%name)
        TestWriter = csv.writer(Test, quoting=csv.QUOTE_ALL)
    except:
        TestWriter = csv.writer(Test, quoting=csv.QUOTE_ALL)
        TestWriter.writerow(['Front Left+','Front Left','Front Right','Front Right+','Mid Left+','Back Top','Back Mid','Back Bottom',
         'Accell X','Accell Y','Accell Z','Gyro X','Gyro Y','Gyro Z','Label','Year','Month','Date','Time'])



    print positions

    pressed0 = 0
    pressed1 = 0
    pressed2 = 0
    pressed3 = 0
    pressed4 = 0
    pressed5 = 0
    pressed6 = 0
    pressed7 = 0
    pressed8 = 0
    pressed9 = 0


    os.environ['SDL_VIDEO_CENTERED'] = '1'
    pygame.init()

    #initialize screen size
    screen = pygame.display.set_mode((1366,768))

    #title of screem
    pygame.display.set_caption("The Smart Chair")

    #set background
    bkg = load_image ('bkg.jpg','images')
    screen.blit(bkg,(0,0))
    pygame.display.flip()

    #Create menu
    mainMenu = cMenu(50, 50, 20, 5,'vertical',100,screen,
                     [('Make Dataset',  11,  None),
                      ('Make Test_dataset',15,None),
                      ('Actuators Activate!',     12,  None),
                      ('Do Everything!', 13, None),
                      ('EXIT',          9,  None)])

    DatasetMaker = cMenu (50, 50, 20, 5,'vertical',100,screen,
                     [('Main Menu',     10, None),
                      ('Evaluate dataset',111,None),
                      ('EXIT', 9, None)])
    DatasetTester = cMenu (50, 50, 20, 5,'vertical',100,screen,
                     [('Main Menu',     10, None),
                      ('Test Dataset',151,None),
                      ('EXIT', 9, None)])

    ChairActuation = cMenu (50, 50, 20, 5,'vertical',100,screen,
                     [('Main Menu',     10, None),
                      ('Tilt resistance 1',131,None),
                      ('Tilt resistance 2',132,None),
                      ('Tilt resistance 3', 133, None),
                      ('Tilt resistance 4', 134, None),
                      ('Tilt resistance 5', 135, None),
                      ('EXIT', 9, None)])

    DoEverything = cMenu (50, 50, 20, 5,'vertical',100,screen,
                          [('No menu here...]',1000,None)])



    state=10
    #tiltResistance = arduino_stuff.sensorRead('5,0',arduino)
    prev_state = 135
    rect_list = []

    #ignore mouse
    pygame.event.set_blocked(pygame.MOUSEMOTION)

    #main Loop
    while True:
        if prev_state != state:
            pygame.event.post(pygame.event.Event(EVENT_CHANGE_STATE, key=0))
            prev_state = state

            if state in range(0,100):
                # Reset the screen before going to the next menu.  Also, put a
                # caption at the bottom to tell the user what is going one
                screen.blit(bkg, (0, 0))

                pygame.display.flip()

        e = pygame.event.wait()

        if e.type == pygame.KEYDOWN or e.type == EVENT_CHANGE_STATE:
            if state == 10:


                rect_list, state = mainMenu.update (e, state)

                if e.type == pygame.QUIT:
                    pygame.quit()
                    quit()





            elif state == 11:

                rect_list, state = DatasetMaker.update(e, state)
                positionRecorderString = ''
                for i in range (0,len(positions)):
                    positionRecorderString += str(i+1)
                    positionRecorderString += ':  '
                    positionRecorderString += positions[i]
                    positionRecorderString += '\n'
                SeatingPositions = positionRecorderString.split('\n')
                arduino_stuff.sensorRead('Pressure', arduino) #buffer
                count = 0
                for i in SeatingPositions:
                    label = myfont.render(i, 1, (255, 255, 255))
                    screen.blit(label, (415,50+25*count))
                    count +=1
                pygame.display.flip()
                if e.type == pygame.QUIT:
                    pygame.quit()
                    quit()




                if (pygame.key.get_pressed()[pygame.K_0] != 0):
                    readKey(10,writer,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_1] != 0):
                    readKey(1,writer,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_2] != 0):
                    readKey(2, writer,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_3] != 0):
                    readKey(3, writer,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_4] != 0):
                    readKey(4, writer,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_5] != 0):
                    readKey(5, writer,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_6] != 0):
                    readKey(6, writer,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_7] != 0):
                    readKey(7, writer,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_8] != 0):
                    readKey(8, writer,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_9] != 0):
                    readKey(9, writer,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_q] != 0):
                    readKey(11, writer, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_w] != 0):
                    readKey(12, writer, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_e] != 0):
                    readKey(13, writer, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_r] != 0):
                    readKey(14, writer, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_t] != 0):
                    readKey(15, writer, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_y] != 0):
                    readKey(16, writer, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_u] != 0):
                    readKey(17, writer, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_i] != 0):
                    readKey(18, writer, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_o] != 0):
                    readKey(19, writer, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_p] != 0):
                    readKey(20, writer, arduino, positions)

            elif state == 111:
                csvFile.close()
                machine_learning.dataset_evaluate(filename)
                csvFile = open(filename, 'ab')
                writer = csv.writer(csvFile, quoting=csv.QUOTE_ALL)
                #open csv, make writer
                state = 11






                    #while pressed1 == 1:
                #    for event in pygame.event.get():
                #        if event.type == pygame.KEYUP:
                #            if event.key == pygame.K_1:
                #                pressed1 = 0
                #    if time.time()-lastTime>.2:
                #        myfile.writerow(
                #            [2, 3, 4, 5, 6, 7, 8, 9, 0, 'Totes RelaxiTowns', str(date_list[0]), str(date_list[1]),
                #             str(date_list[2]), str(datetime.datetime.now().time().replace(microsecond=0))])
                #        lastTime=time.time()
                #        print '1 was pressed'



            elif state == 121:

                #Add functionality for changing value of
                print 'point of no return'

                df = pandas.read_csv(csvFile)
                print ' dataframe ready'
                features_train, features_validation, labels_train, labels_validation =machine_learning.preProcessing(df)
                clf = machine_learning.model_train(features_train, features_validation,
                                                   labels_train, labels_validation,positions)
                print 'classifier initialized'
                data = arduino_stuff.sensorRead('Pressure', arduino)
                print 'Making prediction'
                machine_learning.arduino_read(data, clf, df)
                state = 12



            elif state == 12:

                rect_list, state = ChairActuation.update(e, state)
                t0 = time.time()
                if time.time()-t0>30000:
                    seat_activity = pandas.read_csv(csvLogFile)
                    ###insert functionality for analysis of dataset and whether an action should be taken, what action should be taken++
                    #arduino_stuff.actuate(actuator,'position,')
                    t0 = time.time()
                if e.type == pygame.QUIT:

                    pygame.quit()
                    quit()



            elif state == 13:


                rect_list, state = DoEverything.update(e, state)
                label = myfont.render("Press Escape to return to main menu", 1, (255, 255, 255))
                screen.blit(label, (415, 100))
                pygame.display.flip()
                t0 = time.time()
                csvFile.close()
                DF = pandas.read_csv(filename)
                features_train, features_validation, labels_train, labels_validation = machine_learning.preProcessing(DF)

                classifier, real,fake = machine_learning.model_train(features_train, features_validation,
                                                                     labels_train, labels_validation)
                startTime = time.time()
                firstTime = 1

                while state ==13:

                    events = pygame.event.get()
                    for event in events:
                        if event.type == pygame.KEYDOWN:
                            if event.key == pygame.K_ESCAPE:
                                state = 10
                    tt= time.time()
                    if tt-t0>1:
                        t0=tt
                        data = arduino_stuff.sensorRead('Pressure',arduino)
                        prediction = machine_learning.single_pred(data,classifier)

                        organizingStuff = [prediction, str(date_list[0]), str(date_list[1]),
                                           str(date_list[2]),
                                           str(datetime.datetime.now().time().replace(microsecond=0))]
                        newLine = data + organizingStuff
                        csvLogger.writerow(newLine)
                    if tt - StartTime >=2000 and firstTime !=1 or tt-lastTime>=300:
                        csvLog.close()
                        SeatEvaluator = pandas.read_csv(csvLogFile).Label.tail(900).valueCounts(normalize = True)
                        dominantPosition = SeatEvaluator.index[0]
                        if SeatEvaluator[0]>80:
                            if pandas.read_csv(csvLogFile).Label.tail(60).valueCounts().index[0] == dominantPosition:
####FIX HERE!!![]
                                tiltResistance = arduino_stuff.sensorRead('5,0',arduino)

                                if dominantPosition == 'Relaxed' and tiltResistance<5:
                                    arduino_stuff.sensorRead('5,{0}'.format(tiltResistance + 1), arduino)
                                elif dominantPosition == 'Focused' and tiltResistance>2:
                                    arduino_stuff.sensorRead('5,{0}'.format(tiltResistance - 1), arduino)



                                else:

                                    otherTiltResistances = range(1,tiltResistance)+range(tiltResistance,6)
                                    newTiltResistance = random.choice(otherTiltResistances)
                                    arduino_stuff.sensorRead('5,{0}'.format(newTiltResistance), arduino)





                        csvLog = open(csvLogFile, 'ab')
                        csvLogger = csv.writer(csvLog, quoting=csv.QUOTE_ALL)
                        lastTime = time.time()
                        firstTime= 0



                pygame.display.flip()
                if e.type == pygame.QUIT:
                    pygame.quit()
                    quit()
                csvFile = open(filename, 'ab')
                writer = csv.writer(csvFile, quoting=csv.QUOTE_ALL)



            elif state == 131:
                if tiltResistance != 1:
                    arduino_stuff.sensorRead('5,1',arduino)
                    state = 13
                    tiltResistance = 1

            elif state == 132:
                if tiltResistance != 2:
                    arduino_stuff.sensorRead('5,2',arduino)
                    state = 13
                    tiltResistance=2

            elif state == 133:
                if tiltResistance != 3:
                    arduino_stuff.sensorRead('5,3',arduino)
                    state = 13
                    tiltResistance=3

            elif state == 134:
                if tiltResistance != 4:
                    arduino_stuff.sensorRead('5,4',arduino)
                    state = 13
                    tiltResistance=4

            elif state == 135:
                if tiltResistance != 5:
                    arduino_stuff.sensorRead('5,5',arduino)
                    state = 13
                    tiltResistance=5


            elif state == 15:
                rect_list, state = DatasetTester.update(e, state)

                label = myfont.render("Press Escape to return to main menu", 1, (255, 255, 255))
                screen.blit(label, (415, 100))
                SeatingPositions = positionRecorderString.split('\n')
                arduino_stuff.sensorRead('Pressure', arduino)  # buffer
                count = 0
                for i in SeatingPositions:
                    label = myfont.render(i, 1, (255, 255, 255))
                    screen.blit(label, (415, 50 + 25 * count))
                    count += 1
                pygame.display.flip()

                if e.type == pygame.QUIT:
                    pygame.quit()
                    quit()




                if (pygame.key.get_pressed()[pygame.K_0] != 0):
                    readKey(10,TestWriter,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_1] != 0):
                    readKey(1,TestWriter,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_2] != 0):
                    readKey(2, TestWriter,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_3] != 0):
                    readKey(3, TestWriter,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_4] != 0):
                    readKey(4, TestWriter,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_5] != 0):
                    readKey(5, TestWriter,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_6] != 0):
                    readKey(6, TestWriter,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_7] != 0):
                    readKey(7, TestWriter,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_8] != 0):
                    readKey(8, TestWriter,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_9] != 0):
                    readKey(9, TestWriter,arduino,positions)

                if (pygame.key.get_pressed()[pygame.K_q] != 0):
                    readKey(11, TestWriter, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_w] != 0):
                    readKey(12, TestWriter, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_e] != 0):
                    readKey(13, TestWriter, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_r] != 0):
                    readKey(14, TestWriter, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_t] != 0):
                    readKey(15, TestWriter, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_y] != 0):
                    readKey(16, TestWriter, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_u] != 0):
                    readKey(17, TestWriter, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_i] != 0):
                    readKey(18, TestWriter, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_o] != 0):
                    readKey(19, TestWriter, arduino, positions)

                if (pygame.key.get_pressed()[pygame.K_p] != 0):
                    readKey(20, TestWriter, arduino, positions)
            elif state == 151:
                Test.close()
                csvFile.close()
                MachineLearning_Test_function.Testing(name)

                Test = open(Test_dataset, 'ab')
                TestWriter = csv.writer(Test, quoting=csv.QUOTE_ALL)
                csvFile = open(filename, 'ab')
                writer = csv.writer(csvFile, quoting=csv.QUOTE_ALL)
                state = 15


            else:
                pygame.quit()
                sys.exit()

        # Quit if the user presses the exit button
        if e.type == pygame.QUIT:
            pygame.quit()
            sys.exit()
        if e.type == pygame.KEYDOWN:
            if e.key == pygame.K_ESCAPE:
                pygame.quit()
                sys.exit()

        #update screen "rect_lis"t was in the parenthesis
        pygame.display.update(rect_list)
        pygame.time.Clock().tick(50)
#if __name__ =="__main__":
    #menu_chair()
