#include "SparkFunLSM6DS3.h"
#include "Wire.h"
#include "SPI.h"
LSM6DS3 myIMU( I2C_MODE, 0x6A );  //accel-gyro
int pushbutton = 22;
int fake5v = 24;
int fGround = 26;
int hijack1 = 28;
int hijack2 = 30;
int hijack3 = 32;
int hijack4 = 34;
int hijack5 = 36;

//Master-Arduino
long previousMillis = 0;
String state ;
String msg;
int Position;
int buttonState;
//buttons

void setup() {
  // Open serial communications and wait for port to open:
  Wire.begin();
  Serial.begin(115200);
  pinMode (pushbutton, INPUT);
  pinMode (fake5v, OUTPUT);
  pinMode (fGround, OUTPUT);
  digitalWrite(fake5v, HIGH);
  digitalWrite(fGround, LOW);
  pinMode(hijack1, INPUT);
  pinMode(hijack2, INPUT);
  pinMode(hijack3, INPUT);
  pinMode(hijack4, INPUT);
  pinMode(hijack5, INPUT);

  if ( myIMU.begin() != 0 )
  {
    Serial.println("Device error");
  }

}


void loop() {


  while ( Serial.available() == 0) {}

  String msg = "";

  while (Serial.available() > 0)
  {
    msg += char(Serial.read());
    delayMicroseconds(60);
  }
  //Serial.println(msg);


  if (msg == "Pressure") {
    String dataString = "";


    // read three sensors and append to the string:
    for (int analogPin = 0; analogPin < 16; analogPin++) {
      int sensor = analogRead(analogPin);
      dataString += String(sensor);
      if (analogPin < 15)
      {
        dataString += ",";
      }
    }
    dataString += myIMU.readFloatAccelX(), 10;
    dataString += ",";
    dataString += myIMU.readFloatAccelY(), 10;
    dataString += ",";
    dataString += myIMU.readFloatAccelZ(), 10;
    dataString += ",";
    dataString += myIMU.readFloatGyroX(), 4;
    dataString += ",";
    dataString += myIMU.readFloatGyroY(), 4; 
    dataString += ",";
    dataString += myIMU.readFloatGyroZ(), 4;

    buttonState = digitalRead(pushbutton);
    if (buttonState == 1) {
      dataString = "ShutDown";

    }
    if (digitalRead(hijack1) == 1) {
      dataString = "Position1";
    }
    if (digitalRead(hijack2) == 1) {
      dataString = "Position2";

    }
    if (digitalRead(hijack3) == 1) {
      dataString = "Position3";

    }
    if (digitalRead(hijack4) == 1) {
      dataString = "Position4";

    }
    if (digitalRead(hijack5) == 1) {
      dataString = "Position5";

    }
    Serial.println(dataString);
    previousMillis = millis();
  }
  else if (msg == "Startup")
  {
    software_Reset();
  }

  else {

    //"adress of slave" + "," + "message for slave(0 if request)"

    int address = getValue(msg, ',', 0).toInt();
    int command = getValue(msg, ',', 1).toInt();
    if (command == 0) {
      Wire.requestFrom(address, 1);

      while (Wire.available()) {
        Position = Wire.read();

      }
      Serial.println (Position);
    }
    else {
      Wire.beginTransmission(address);
      Wire.write(command);
      Wire.endTransmission();

    }
  }




}

String getValue(String data, char separator, int index)
{
  int found = 0;
  int strIndex[] = { 0, -1 };
  int maxIndex = data.length() - 1;

  for (int i = 0; i <= maxIndex && found <= index; i++) {
    if (data.charAt(i) == separator || i == maxIndex) {
      found++;
      strIndex[0] = strIndex[1] + 1;
      strIndex[1] = (i == maxIndex) ? i + 1 : i;
    }
  }
  return found > index ? data.substring(strIndex[0], strIndex[1]) : "";
}


void software_Reset() // Restarts program from beginning but does not reset the peripherals and registers
{
  asm volatile ("  jmp 0");
}






