import pandas as pd
import os
import glob
from sklearn.model_selection import train_test_split
from sklearn.neighbors import KNeighborsClassifier
from sklearn.ensemble import RandomForestClassifier, GradientBoostingClassifier, ExtraTreesClassifier

from sklearn.metrics import accuracy_score
import csv

names = ["Nearest Neighbors BT",  "Random Forest", "GTB", "Extra trees", ]

classifiers = [
    KNeighborsClassifier(5, algorithm="ball_tree"),

    RandomForestClassifier(max_depth=1000, n_estimators=100, max_features=16),
    GradientBoostingClassifier(max_depth=1000, n_estimators=100, max_features=16),

    ExtraTreesClassifier(n_estimators=200, max_depth=None, random_state=0)]
dataset = 'C:\Users\osmun\Desktop\Work\CHAIR\Master\Datasets\BOZO.csv'

train_dataset = pd.read_csv(dataset)
train_dataset = train_dataset[train_dataset.Label != 'Core Active']
os.chdir('C:\Users\osmun\Desktop\Work\Excel\Simen')
directory = 'C:\Users\osmun\Desktop\Work\Excel\Simen'
i = 0
test_dataset = {}
train_dataset = train_dataset.drop(['year', 'month', 'Date', 'time'], 1)

train, validation = train_test_split(train_dataset, test_size=0.1)

train_labels = train.Label
train_features = train.drop('Label', 1)
# train_features =(train_features - train_features.mean()) / (train_features.max() - train_features.min())

validation_labels = validation.Label
validation_features = validation.drop('Label', 1)
for filename in os.listdir(directory):
    if filename.endswith('.csv'):
        print filename
        test_dataset[i] = pd.read_csv(filename)
        test_dataset[i] = test_dataset[i].drop(['Year', 'Month', 'Day', 'Time', 'Tilt Resistance'], 1)


    # validation_features =(validation_features - validation_features.mean()) / (validation_features.max() - validation_features.min())

        test_labels = test_dataset[i].Label
        test_features = test_dataset[i].drop('Label', 1)
        classifier_dict = {}
        i= 0
        for name in names:
            classifier_dict[name] = classifiers[i]
            i = i + 1
        validation_results = {}
        test_results = {}

        evalDict = {}
        test_labels2 = test_labels.reset_index(drop=True)
        for name in names:
            classifier_dict[name].fit(train_features, train_labels)
            validation_results[name] = classifier_dict[name].predict(validation_features)
            test_results[name] = classifier_dict[name].predict(test_features)
            evalDict[name] = accuracy_score(test_labels2, test_results[name])


        VL = validation_labels.tolist()




        Sorted_Dict_Values = sorted(evalDict.values(), reverse=True)
        Sorted_Dict_Keys = sorted(evalDict, key=evalDict.get, reverse=True)
#for i in range(len(evalDict)):
    #print'Accuracy {0} : {1}'.format(Sorted_Dict_Keys[i], Sorted_Dict_Values[i])

        outputfile, extension =  os.path.splitext(filename)
        outputfile +='corrected'
        output = pd.read_csv(filename)
        output['Corrected Label']=test_results["Nearest Neighbors BT"]
        output.to_csv(path_or_buf='{2}\Corrected\{0}{1}'.format(outputfile,extension,directory))
        i += 1
