import DriveUploader2
import serial
import csv
import pandas as pd
import machineLearning
from time import sleep,time
import datetime
from os import system
from random import choice
from os import walk

LastChange = time()
def buttonPressShutdown():
    myfile.close()
    DriveUploader2.uploadFile([filename])
    print 'shutting down in 5 sec'
    sleep(5)
    system("sudo shutdown -h now")

def analyseSeating(myfile,newPosition):
    myfile.close()
    analyzer = pd.read_csv(filename).Label.tail(1800)#last hour
    overview = analyzer.value_counts(normalize = True)
    print overview
    myfile = open(filename,'ab')
    wr = csv.writer(myfile, quoting = csv.QUOTE_ALL)



    if  overview.index[0]!='Seat available':
        print 'Waaay too {0}... \n{1}% actually!'.format(overview.index[0],overview[0])
        alternatives = range(1,int(newPosition))+range (int(newPosition),6)
        new =  choice (alternatives)      
        arduinoSens.write('5,{0}'.format(new))
        LastChange = time()
        newPosition = str(new)
        arduinoSens.write('Pressure')
    return  myfile, wr,newPosition,LastChange

TestingFiles = ['Person1,day1.csv','Person1,day2.csv','Person2,day1.csv','Person2,day2.csv']
existingFiles=[]
for (dirpath,dirnames,filenames) in walk('/home/pi/Desktop/Testing datasets'):
    existingFiles.extend(filenames)
print existingFiles
print TestingFiles
for i in [3,2,1,0]:
    print TestingFiles[i]
    if TestingFiles[i] not in existingFiles:
        currentFile = TestingFiles[i]
    
classifier = machineLearning.training()
arduinoSens = serial.Serial('/dev/ttyACM0',115200)

arduinoSens.write('Startup')
sleep(3)
while arduinoSens.inWaiting ():
    print arduinoSens.read(1)
arduinoSens.write('5,0')
sleep(.5)
newPosition = arduinoSens.readline().strip()

filename = '/home/pi/Desktop/Testing datasets/{}'.format(currentFile)

try:
    pd.read_csv(filename)
    myfile = open(filename,'ab')
    wr = csv.writer(myfile, quoting = csv.QUOTE_ALL)
except:
    myfile = open(filename,'ab')
    wr = csv.writer(myfile, quoting = csv.QUOTE_ALL)
    arduinoSens.write('yo')
    preemptive = arduinoSens.readline()


    wr.writerow(["Front Left+","Front Left","Front Right","Front Right+","Mid Left+","Mid Left","Mid Right","Mid Rght+","Back Left","Back Right","Back+ Left","Back+ Right","Top Left","Top Right","Lumbar Left","Lumbar Right","Accel X","Accel Y","Accel Z","Gyro X","Gyro Y","Gyro Z","Raw Accel X","Raw Accel Y","Raw Accel Z","Label","Year","Month","Date","Time","Tilt Resistance"])
print 'It begins! '


while True:
    while arduinoSens.inWaiting ():
        print arduinoSens.read(1)
    arduinoSens.write('Pressure')
    
    data = arduinoSens.readline()
    if 'ShutDown' in data:
        print 'shutdown'
        buttonPressShutdown()

    if 'Position' in data:
       
        if 'Position1' in data:
            print 'Something is crappening'
            newPosition = '1'
            arduinoSens.write('5,1')
        if 'Position2'in data:
            newPosition = '2'
            arduinoSens.write('5,2')
        if 'Position3'in data:
            newPosition = '3'
            arduinoSens.write('5,3')
        if 'Position4'in data:
            newPosition = '4'
            arduinoSens.write('5,4')
        if 'Position5'in data:
            newPosition = '5'
            arduinoSens.write('5,5')
        sleep(5)
        while arduinoSens.inWaiting ():
            print arduinoSens.read(1)
        arduinoSens.write('Pressure')
        data = arduinoSens.readline()
        
    data = data.rstrip('\r\n')
    data = data.split(',')

    datapoint = pd.Series(data = data, index = ["Front Left+","Front Left","Front Right","Front Right+","Mid Left+","Mid Left","Mid Right","Mid Rght+","Back Left","Back Right","Back+ Left","Back+ Right","Top Left","Top Right","Lumbar Left","Lumbar Right","Accel X","Accel Y","Accel Z","Gyro X","Gyro Y","Gyro Z","Raw Accel X","Raw Accel Y","Raw Accel Z"])
    temp = datapoint.drop(["Accel X","Accel Y","Accel Z","Gyro X","Gyro Y","Gyro Z","Raw Accel X","Raw Accel Y","Raw Accel Z"])
    prediction = classifier.predict(temp)
    data.append(prediction[0])
    datapoint.Prediction = prediction[0]
    sleep(.8)
    datapoint = datapoint.append(pd.Series([prediction[0],datetime.datetime.now().time().replace(microsecond=0),datetime.datetime.now().day,datetime.datetime.now().month,datetime.datetime.now().year,newPosition     ],index = ["Label","Time","Day","Month","Year","Tilt Resistance"]))
    print datapoint
    wr.writerow(datapoint)
    if 'day2' in filename:
        if  time() - LastChange>900:
            myfile, wr, newPosition, LastChange = analyseSeating(myfile,newPosition)


